package ru.ulstu.report.service;

import org.springframework.stereotype.Service;
import ru.ulstu.report.model.ReportPeriod;
import ru.ulstu.report.repository.ReportPeriodRepository;

import java.util.List;

@Service
public class ReportPeriodService {
    private final ReportPeriodRepository reportPeriodRepository;

    public ReportPeriodService(ReportPeriodRepository reportPeriodRepository) {
        this.reportPeriodRepository = reportPeriodRepository;
    }

    public List<ReportPeriod> getReportPeriods() {
        return reportPeriodRepository.findAllByOrderByStartDateDesc();
    }

    public ReportPeriod save(ReportPeriod reportPeriod) {
        ReportPeriod dbReportPeriod;
        if (reportPeriod.getId() != null) {
            dbReportPeriod = getById(reportPeriod.getId());
            dbReportPeriod.setStartDate(reportPeriod.getStartDate());
            dbReportPeriod.setEndDate(reportPeriod.getEndDate());
        } else {
            dbReportPeriod = reportPeriod;
        }
        return reportPeriodRepository.save(dbReportPeriod);
    }

    public void delete(ReportPeriod reportPeriod) {
        reportPeriodRepository.deleteById(reportPeriod.getId());
    }

    public ReportPeriod getById(Integer reportPeriodId) {
        return reportPeriodRepository
                .findById(reportPeriodId)
                .orElseThrow(() -> new RuntimeException("Report period not found by id"));
    }
}
